Last Comment Bug 699917 - Crash (Java OOM) on ajax site
: Crash (Java OOM) on ajax site
Status: RESOLVED FIXED
[native-crash]
: crash
Product: Firefox for Android
Classification: Client Software
Component: General (show other bugs)
: unspecified
: ARM Android
: P1 critical (vote)
: ---
Assigned To: Kartikaya Gupta (email:kats@mozilla.com)
:
Mentors:
http://ajaxload.info
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2011-11-04 14:06 PDT by Tony Chung [:tchung]
Modified: 2012-01-09 11:03 PST (History)
6 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---
fixed
11+


Attachments
logcat of crash (514.16 KB, text/plain)
2011-11-04 14:06 PDT, Tony Chung [:tchung]
no flags Details
logcat while panning (166.05 KB, text/plain)
2011-11-04 15:01 PDT, Tony Chung [:tchung]
no flags Details

Description Tony Chung [:tchung] 2011-11-04 14:06:13 PDT
Created attachment 572071 [details]
logcat of crash

While running pcwalton's 11-04 try server build, i was able to crash each time when activating the ajaxload.info site.

Crash log: https://crash-stats.mozilla.com/report/index/bp-c1c52481-cfca-44a2-8091-f2e662111104

Logcat attached.

Frame 	Module 	Signature [Expand] 	Source
0 	libdvm.so 	dvmMarkObjectNonNull 	
1 	libdvm.so 	dvmGetThreadStatusStr 	
2 	libdvm.so 	dvmDumpThread 	
3 	libdvm.so 	dvmDumpThread 	
4 	libdvm.so 	dvmGcScanRootThreadGroups 	
5 	libdvm.so 	dvmHeapMarkRootSet 	
6 	libdvm.so 	dvmCollectGarbageInternal 	
7 		@0xffffe 	
8 	libdvm.so 	dvmHeapSourceStartupAfterZygote 	
9 	libdvm.so 	dvmDetachCurrentThread 	
10 	libc.so 	__thread_entry 	
11 	libc.so 	pthread_create 	

REpro:
1) install tryserver nightly Native build, Nexus S, Android 2.3.6:  http://ftp.mozilla.org/pub/mozilla.org/mobile/try-builds/pwalton@mozilla.com-abc151172fd1/
2) launch fennec, and visit URL
3) click the "Generate it" button in the yellow box
4) wait a few minutes, and verify Fennec crashes

Expected:
- no crash

Actual:
- crash with logcat and socorro report
Comment 1 Naoki Hirata :nhirata (please use needinfo instead of cc) 2011-11-04 14:23:44 PDT
looking at tchung's logcat :
11-04 13:58:36.078: ERROR/AndroidRuntime(10419): FATAL EXCEPTION: main
11-04 13:58:36.078: ERROR/AndroidRuntime(10419): java.lang.OutOfMemoryError: bitmap size exceeds VM budget
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.graphics.BitmapFactory.nativeDecodeAsset(Native Method)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.graphics.BitmapFactory.decodeStream(BitmapFactory.java:460)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.graphics.BitmapFactory.decodeResourceStream(BitmapFactory.java:336)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.graphics.BitmapFactory.decodeResource(BitmapFactory.java:359)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at org.mozilla.fennec.gfx.LayerController.getDrawable(LayerController.java:129)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at org.mozilla.fennec.gfx.LayerController.getBackgroundPattern(LayerController.java:120)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at org.mozilla.fennec.gfx.LayerRenderer.<init>(LayerRenderer.java:79)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at org.mozilla.fennec.gfx.LayerView.<init>(LayerView.java:69)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at org.mozilla.fennec.gfx.LayerController.<init>(LayerController.java:101)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at org.mozilla.gecko.GeckoApp.onCreate(GeckoApp.java:1047)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.app.Instrumentation.callActivityOnCreate(Instrumentation.java:1047)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.app.ActivityThread.performLaunchActivity(ActivityThread.java:1611)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.app.ActivityThread.handleLaunchActivity(ActivityThread.java:1663)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.app.ActivityThread.access$1500(ActivityThread.java:117)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.app.ActivityThread$H.handleMessage(ActivityThread.java:931)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.os.Handler.dispatchMessage(Handler.java:99)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.os.Looper.loop(Looper.java:130)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at android.app.ActivityThread.main(ActivityThread.java:3683)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at java.lang.reflect.Method.invokeNative(Native Method)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at java.lang.reflect.Method.invoke(Method.java:507)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at com.android.internal.os.ZygoteInit$MethodAndArgsCaller.run(ZygoteInit.java:839)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at com.android.internal.os.ZygoteInit.main(ZygoteInit.java:597)
11-04 13:58:36.078: ERROR/AndroidRuntime(10419):     at dalvik.system.NativeStart.main(Native Method)
11-04 13:58:36.082: WARN/ActivityManager(115):   Force finishing activity org.mozilla.fennec/.App
11-04 13:58:36.085: WARN/ActivityManager(115):   Force finishing activity org.mozilla.fennec/.CrashReporter
Comment 2 Tony Chung [:tchung] 2011-11-04 15:01:23 PDT
Created attachment 572089 [details]
logcat while panning

i got the same crash signature, but this time panning and zooming around another website, www.a9.com.

Attaching logcat
Comment 3 Naoki Hirata :nhirata (please use needinfo instead of cc) 2011-11-04 15:51:36 PDT
Also occurred when flipping orientations on a webm movie:
http://people.mozilla.com/~nhirata/html_tp/big_buck_bunny_480p.webm
Comment 4 Patrick Walton (:pcwalton) 2011-11-04 16:18:12 PDT
kats' work decreased the size of the background image, so this may not be a problem anymore.
Comment 5 Justin Lebar (not reading bugmail) 2011-11-07 21:35:16 PST
Naoki, why is this [MemShrink]?
Comment 6 Naoki Hirata :nhirata (please use needinfo instead of cc) 2011-11-07 21:50:28 PST
I saw that the bitmap size exceeded the VM budget in the Java portion within Tony's log:
11-04 13:58:36.078: ERROR/AndroidRuntime(10419): FATAL EXCEPTION: main
11-04 13:58:36.078: ERROR/AndroidRuntime(10419): java.lang.OutOfMemoryError: bitmap size exceeds VM budget

Based on comment 4, I take it that this is not a Memshrink issue?  I removed the memshrink tag.
Comment 7 Justin Lebar (not reading bugmail) 2011-11-08 06:30:18 PST
Ah, I see.

This isn't normally the kind of issue that the MemShrink team looks at -- this seems more like a correctness issue than a we're-using-too-much-memory issue.  But maybe not!  In any case, we should verify that this issue is fixed.
Comment 8 Kartikaya Gupta (email:kats@mozilla.com) 2011-11-21 11:53:32 PST
Based on the stack traces in the logcats, this should have been fixed with:
https://hg.mozilla.org/users/pwalton_mozilla.com/birch-pan-zoom/rev/06b9cad5183f

I'm going to mark this as fixed, and if there are still crashes with the same symptoms, a new bug should be opened for it.

Note You need to log in before you can comment on or make changes to this bug.